<template>
  <div
    id="main"
    :style="`
        width: ${$store.state.tilesize * $store.state.viewportCols}px;
        height: ${$store.state.tilesize * $store.state.viewportRows}px;
  `"
  >
    <grid :level="level" />
    <player
      ref="player"
      :keyboard-input="keyboardInput"
      :level="level"
      :start-position="playerStartPos"
    />
  </div>
</template>

<script>
import level from '~/levels/level1.json';

export default {
  name: 'IndexPage',
  props: {
    keyboardInput: Object,
  },
  data() {
    return {
      lastTimestamp: 0,
      level,
      prevLevel: null,
      nextLevel: '/level01',
      playerStartPos: { x: 200, y: -84 },
    };
  },
  mounted() {
    this.$nextTick(() => {
      requestAnimationFrame(this.update);
    });
  },
  methods: {
    update(timestamp) {
      // deltatime in fraction of a second
      const deltaTime = (timestamp - this.lastTimestamp) / 1000;
      this.lastTimestamp = timestamp;

      if (this.$refs && this.$refs.player) {
        this.$refs.player.update(deltaTime);
      }

      // keep this loop going for ever
      requestAnimationFrame(this.update);
    },
    goToNextLevel() {
      if (this.nextLevel)
        this.$router.push(this.nextLevel);
    },
    goToPreviousLevel() {
      if (this.prevLevel)
        this.$router.push(this.prevLevel);
    },
  },
}
</script>
